//
// Symlink - ntfs.sys Ƀpb`𓖂Ăăt@Cɑ΂WNVLɂ
//
#include <ntddk.h>
#include "symlink.h"

//
// ̃hCoIuWFNg
//
PDRIVER_OBJECT SymlinkDriver;

//
// ̃hCo̐foCXIuWFNg
//
PDEVICE_OBJECT SymlinkController;

//
// A[histO
//
BOOLEAN UnloadInProgress = FALSE;

//
// is IRP ̐
//
#if DBG
ULONG OutstandingIRPCount = 0;
KSPIN_LOCK CountMutex;
#endif // DBG

//
// fBXpb`Ggp̊SpX lookaside
//
PAGED_LOOKASIDE_LIST FullPathLookaside;


/////////////////////////////////////////////////////////////////////////////
//
//  e[`ɃeLXgZNV蓖
//
/////////////////////////////////////////////////////////////////////////////
NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);

#if DBG
VOID SymlinkUnload(IN PDRIVER_OBJECT DriverObject);
#endif

VOID SymlinkFsNotification(
	PDEVICE_OBJECT DeviceObject,
	BOOLEAN FsActive
	);

NTSTATUS 
SymlinkHookDone(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp,
	IN PVOID Context
	);

BOOLEAN SymlinkFilterDevice(PDEVICE_OBJECT DeviceObject);

VOID SymlinkResolveLink(IN PIRP Irp, IN PIO_STACK_LOCATION IrpSp, IN PWSTR fullPathName);

BOOLEAN 
SymlinkFastIoCheckIfPossible(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN BOOLEAN Wait,
	IN ULONG LockKey,
	IN BOOLEAN CheckForReadOperation,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoRead(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN BOOLEAN Wait,
	IN ULONG LockKey,
	OUT PVOID Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoWrite(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN BOOLEAN Wait,
	IN ULONG LockKey,
	IN PVOID Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoQueryBasicInfo(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	OUT PFILE_BASIC_INFORMATION Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoQueryStandardInfo(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	OUT PFILE_STANDARD_INFORMATION Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoLock(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PLARGE_INTEGER Length,
	PEPROCESS ProcessId,
	ULONG Key,
	BOOLEAN FailImmediately,
	BOOLEAN ExclusiveLock,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoUnlockSingle(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PLARGE_INTEGER Length,
	PEPROCESS ProcessId,
	ULONG Key,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoUnlockAll(
	IN PFILE_OBJECT FileObject,
	PEPROCESS ProcessId,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoUnlockAllByKey(
	IN PFILE_OBJECT FileObject,
	PEPROCESS ProcessId,
	ULONG Key,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoDeviceControl(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	IN PVOID InputBuffer,
	IN ULONG InputBufferLength,
	OUT PVOID OutputBuffer,
	IN ULONG OutputBufferLength,
	IN ULONG IoControlCode,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

VOID 
SymlinkFastIoDetachDevice(
	PDEVICE_OBJECT SourceDevice,
	PDEVICE_OBJECT TargetDevice
	);

BOOLEAN 
SymlinkFastIoQueryNetworkOpenInfo(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	OUT struct _FILE_NETWORK_OPEN_INFORMATION *Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoMdlRead(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoPrepareMdlWrite(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoMdlWriteComplete(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PMDL MdlChain,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoReadCompressed(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PVOID Buffer,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	OUT struct _COMPRESSED_DATA_INFO *CompressedDataInfo,
	IN ULONG CompressedDataInfoLength,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoWriteCompressed( 
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PVOID Buffer,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	OUT struct _COMPRESSED_DATA_INFO *CompressedDataInfo,
	IN ULONG CompressedDataInfoLength,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN 
SymlinkFastIoQueryOpen(
	IN PIRP Irp,
	OUT PFILE_NETWORK_OPEN_INFORMATION NetworkInformation,
	IN PDEVICE_OBJECT DeviceObject
	);

BOOLEAN
SymlinkQueryRoot(
	PDEVICE_OBJECT DeviceObject,
	PHOOK_EXTENSION hookExt
	);

VOID 
SymlinkGetFullPath(
	PFILE_OBJECT fileObject,
	PHOOK_EXTENSION hookExt,
	PWSTR fullPathName
	);

VOID SymlinkDeleteDevice(IN PDEVICE_OBJECT DeviceObject);

BOOLEAN CallBackFastIoDeviceControl(
	IN PFILE_OBJECT FileObject, IN BOOLEAN Wait,
	IN PVOID InputBuffer, IN ULONG InputBufferLength,
	OUT PVOID OutputBuffer, IN ULONG OutputBufferLength, IN ULONG IoControlCode,
	OUT PIO_STATUS_BLOCK IoStatus, IN PDEVICE_OBJECT DeviceObject);

VOID SymlinkQueryAttributeTag(IN PIRP Irp, IN PIO_STACK_LOCATION IrpSp);

#ifdef ALLOC_PRAGMA
#pragma alloc_text(INIT, DriverEntry)
#if DBG
#pragma alloc_text(PAGE, SymlinkUnload)
#endif
#pragma alloc_text(PAGE, SymlinkFsNotification)
#pragma alloc_text(PAGE, SymlinkHookDone)
#pragma alloc_text(PAGE, SymlinkFilterDevice)
#pragma alloc_text(PAGE, SymlinkResolveLink)
#pragma alloc_text(PAGE, SymlinkFastIoCheckIfPossible)
#pragma alloc_text(PAGE, SymlinkFastIoRead)
#pragma alloc_text(PAGE, SymlinkFastIoWrite)
#pragma alloc_text(PAGE, SymlinkFastIoQueryBasicInfo)
#pragma alloc_text(PAGE, SymlinkFastIoQueryStandardInfo)
#pragma alloc_text(PAGE, SymlinkFastIoLock)
#pragma alloc_text(PAGE, SymlinkFastIoUnlockSingle)
#pragma alloc_text(PAGE, SymlinkFastIoUnlockAll)
#pragma alloc_text(PAGE, SymlinkFastIoUnlockAllByKey)
#pragma alloc_text(PAGE, SymlinkFastIoDeviceControl)
#pragma alloc_text(PAGE, SymlinkFastIoDetachDevice)
#pragma alloc_text(PAGE, SymlinkFastIoQueryNetworkOpenInfo)
#pragma alloc_text(PAGE, SymlinkFastIoMdlRead)
#pragma alloc_text(PAGE, SymlinkFastIoPrepareMdlWrite)
#pragma alloc_text(PAGE, SymlinkFastIoMdlWriteComplete)
#pragma alloc_text(PAGE, SymlinkFastIoReadCompressed)
#pragma alloc_text(PAGE, SymlinkFastIoWriteCompressed)
#pragma alloc_text(PAGE, SymlinkFastIoQueryOpen)
#pragma alloc_text(PAGE, SymlinkQueryRoot)
#pragma alloc_text(PAGE, SymlinkGetFullPath)
#pragma alloc_text(PAGE, SymlinkDeleteDevice)
#pragma alloc_text(PAGE, CallBackFastIoDeviceControl)
#pragma alloc_text(PAGE, SymlinkQueryAttributeTag)
#endif


//----------------------------------------------------------------------
//
// SymlinkQueryRoot
//
// hookExt  VDO ̖Oݒ肷B
// hookExt->FileSystem ͂܂ĂȂȂ̂
// GȂƁB
//
//----------------------------------------------------------------------
BOOLEAN
SymlinkQueryRoot(
	PDEVICE_OBJECT DeviceObject,
	PHOOK_EXTENSION hookExt
	)
{
	OBJECT_NAME_INFORMATION nameInfo;
	POBJECT_NAME_INFORMATION nameBuffer;
	ULONG bufferLength;
	NTSTATUS status;

	PAGED_CODE();
	hookExt->RootChecked = TRUE;

	status = ObQueryNameString(DeviceObject, &nameInfo, sizeof(OBJECT_NAME_INFORMATION), &bufferLength);
	if (!NT_SUCCESS(status) && status != STATUS_INFO_LENGTH_MISMATCH) {
		KdPrint(("Symlink: Cannot query object name. status=%x\n", status));
		return FALSE;
	}
	//KdPrint(("Symlink: required buffer length=%lu\n", bufferLength));
	nameBuffer = ExAllocatePoolWithTag(NonPagedPool, bufferLength, 'lmyS');
	if (!nameBuffer) {
		KdPrint(("Symlink: Not enough memory allocating name buffer.\n"));
		return FALSE;
	}
	status = ObQueryNameString(DeviceObject, nameBuffer, bufferLength, &bufferLength);
	if (!NT_SUCCESS(status)) {
		KdPrint(("Symlink: Cannot query object name.\n"));
		ExFreePool(nameBuffer);
		return FALSE;
	}
	//
	// O󂾂G[ɂ
	//
	if (!nameBuffer->Name.Length) {
		KdPrint(("Symlink: Object name is empty.\n"));
		ExFreePool(nameBuffer);
		return FALSE;
	}

	KdPrint(("Symlink: object name: %wZ\n", &nameBuffer->Name));
	hookExt->Root = nameBuffer;

	return TRUE;
}

//----------------------------------------------------------------------
//
// SymlinkGetFullPath
//
// t@CIuWFNgƃt@CA`ĊSpXԂB
//
//----------------------------------------------------------------------
VOID 
SymlinkGetFullPath(
	PFILE_OBJECT fileObject,
	PHOOK_EXTENSION hookExt,
	PWSTR fullPathName
	)
{
	ULONG pathLen, prefixLen, slashes;
	PWSTR pathOffset, ptr;
	PFILE_OBJECT relatedFileObject;
	PUNICODE_STRING fileName;
	PUNICODE_STRING relatedName;

	PAGED_CODE();
	if (!hookExt || !fullPathName)
		return;
	fullPathName[0] = 0;

	//
	// Ot@CIuWFNg\z
	//

	//
	// t@CIuWFNgȂΖOq˂邱ƂłȂ
	//
	if (!fileObject)
		return;

	//
	// vtBbNX̒vZ
	//
	if (hookExt->Root) {
		prefixLen = hookExt->Root->Name.Length / sizeof(WCHAR);
	} else if (!hookExt->RootChecked) {
		if (!SymlinkQueryRoot(fileObject->DeviceObject, hookExt))
			return;
		if (!hookExt->Root)
			return;
		prefixLen = hookExt->Root->Name.Length / sizeof(WCHAR);
	} else {
		// [gfBNgs
		return;
	}

	//
	// ϐ
	//
	fileName = NULL;
	relatedName = NULL;

	//
	// IuWFNgɊÂĖO\z
	//

	//
	// ̎_ŖOȂ΁AfoCXւ raw ANZX
	// ΃pX̍\zɂĂ͈ӖȂȂ̂ŃG[ɂ
	//
	if (!fileObject->FileName.Buffer)
		return;

	//
	// SȃpX쐬B܂AZp[^̋󔒂Ɛ擪̃vtBbNX
	// lĒvZ
	//
	fileName = &fileObject->FileName;

	pathLen = fileName->Length / sizeof(WCHAR) + prefixLen;
	relatedFileObject = fileObject->RelatedFileObject;

	//
	// ΃t@C̏ꍇ̂݊֘At@CIuWFNg
	//
	if (fileName->Buffer[0] != L'\\' && 
		relatedFileObject && relatedFileObject->FileName.Length) {

		relatedName = &relatedFileObject->FileName;
		pathLen += relatedName->Length / sizeof(WCHAR) + 1;
	}

	//
	// OI
	//
	if (pathLen >= MAXPATHLEN)
		return;

	//
	// ܂[gfBNg擪ɒǉ
	//
	ASSERT(hookExt->Root);
	RtlCopyMemory(fullPathName, hookExt->Root->Name.Buffer, hookExt->Root->Name.Length);

	//
	// pX\z
	//
	fullPathName[pathLen] = 0;

	pathOffset = fullPathName + pathLen - fileName->Length / sizeof(WCHAR);
	memcpy(pathOffset, fileName->Buffer, fileName->Length);

	//
	// FIXME: RelatedFileObject->FileName Ă͂Ȃ
	// ͂ IRP_MJ_QUERY_INFORMATION 𔭍s FSD ɐq˂ׂ
	//
	if (fileName->Buffer[0] != L'\\' && 
		relatedFileObject && relatedFileObject->FileName.Length) {

		//
		// obNXbV̋؂ǉ\vfRs[
		//
		pathOffset[-1] = L'\\';
		pathOffset -= relatedName->Length / sizeof(WCHAR) + 1;

		memcpy(pathOffset, relatedName->Buffer, relatedName->Length);

		//
		// 擪ɗ]ȃobNXbV菜
		//
		//if (hookExt->LogicalDrive &&
		//	pathLen > 7 && fullPathName[6] == L'\\' && fullPathName[7] == L'\\') {

		//	wcscpy(fullPathName + 6, fullPathName + 7);
		//}
	}

}


//----------------------------------------------------------------------
//
// SymlinkDeleteDevice
//
// Symlink̃foCXIuWFNg폜邽߂ɕKvȏׂčsA
// 폜
//
//----------------------------------------------------------------------
VOID SymlinkDeleteDevice(IN PDEVICE_OBJECT DeviceObject)
{
	PHOOK_EXTENSION deviceExtension;
	POBJECT_NAME_INFORMATION nameInfo;

	PAGED_CODE();
	if (DeviceObject != SymlinkController) {
		deviceExtension = (PHOOK_EXTENSION)DeviceObject->DeviceExtension;
		// t@CVXeIuWFNgꍇ͐؂藣
		if (deviceExtension->FileSystem) {
			KdPrint(("Symlink about to detach %p from %p.\n", DeviceObject, deviceExtension->FileSystem));
			IoDetachDevice(deviceExtension->FileSystem);
			deviceExtension->FileSystem = NULL;
		}
		// [gpXLĂꍇ̓pXɎgĂ
		if (deviceExtension->Root) {
			nameInfo = deviceExtension->Root;
			deviceExtension->Root = NULL;
			ExFreePool(nameInfo);
		}
	}
	// ŌɃfoCXIuWFNĝ폜
	IoDeleteDevice(DeviceObject);
}


//----------------------------------------------------------------------
//
// SymlinkFilterDevice
//
// p[^Ŏw肳ꂽt@CVXefoCXɃtB^tB
//
//----------------------------------------------------------------------
BOOLEAN SymlinkFilterDevice(PDEVICE_OBJECT DeviceObject)
{
	PDEVICE_OBJECT checkDevice, hookDevice;
	NTSTATUS status;
	PHOOK_EXTENSION deviceExtension;

	PAGED_CODE();
	//
	// t@CVXeɍ I/O fBXpb`[`Ȃ΁A
	// tB^ׂłȂ
	//
	if (!DeviceObject->DriverObject->FastIoDispatch) {
		KdPrint(("Symlink: Choosing not to filter a file system with no "
		         "fast dispatch routines.\n"));
		return FALSE;
	}

	//
	// łɐڑς݂Ȃ牽ȂŐƂ݂Ȃ
	//
	checkDevice = DeviceObject;
	while (checkDevice) {
		if (checkDevice->DriverObject == SymlinkDriver) {
			KdPrint(("Symlink: Already attahced.\n"));
			return TRUE;
		}
		checkDevice = checkDevice->AttachedDevice;
	}

	KdPrint(("Symlink: Filtering file system %p\n", DeviceObject));

	//
	// hCuĂȂ{[
	// ufBXN̊ǗvhCuǉƁA
	// hCuIԑOɃ}EgĂ܂B
	// ܂肱̒iKœK؂ȃhCu擾邱Ƃ͕s\
	//

	//
	// t@CVXeɎtVfoCX쐬
	//
	status = IoCreateDevice(SymlinkDriver,
	                        sizeof(HOOK_EXTENSION),
	                        NULL,
	                        DeviceObject->DeviceType,
	                        0,
	                        FALSE,
	                        &hookDevice);
	if (!NT_SUCCESS(status)) {
		return FALSE;
	}

	//
	// ŏʂɐڑꂽfoCX𔻒肵ăfoCXg𖄂߁A
	// tOK؂ɐݒ肷B
	//
	deviceExtension = (PHOOK_EXTENSION)hookDevice->DeviceExtension;

	hookDevice->Flags |= (DeviceObject->Flags & (DO_BUFFERED_IO | DO_DIRECT_IO));

	if (DeviceObject->DeviceType == FILE_DEVICE_NETWORK_FILE_SYSTEM)
		SymlinkQueryRoot(DeviceObject, deviceExtension);

	deviceExtension->FileSystem =
		IoAttachDeviceToDeviceStack(hookDevice, DeviceObject);
	if (!deviceExtension->FileSystem) {
		KdPrint(("Symlink: Failed to attach hook device %p to device %p.\n",
		         hookDevice, DeviceObject));
		SymlinkDeleteDevice(hookDevice);
		return FALSE;
	}

	KdPrint(("Symlink: Attached new hook device %p to device %p.\n",
	         hookDevice, deviceExtension->FileSystem));
	hookDevice->Flags &= ~DO_DEVICE_INITIALIZING;

	return TRUE;
}


#if DBG
//----------------------------------------------------------------------
//
// SymlinkQueryUnload
//
// A[ĥ߂ɂׂẴfoCX؂藣
//
//----------------------------------------------------------------------
VOID 
SymlinkQueryUnload(
	PIO_STATUS_BLOCK IoStatus
	)
{
	KIRQL oldirql;
	PDEVICE_OBJECT device, nextDevice;

	//
	// XsbN̋Ԃ݂̂ł̃[`̂̓y[WO\
	// ZNVɒuȂAy[WO\R[hQƂĂ̂
	// y[WOs\ȂƂɌĂяoĂ͂Ȃ
	//
	PAGED_CODE();
	//
	// A[h\?
	//
	KeAcquireSpinLock(&CountMutex, &oldirql);
	IoStatus->Information = OutstandingIRPCount;

	//
	// is IRP ݂邩?
	//
	if (OutstandingIRPCount) {
		KeReleaseSpinLock(&CountMutex, oldirql);
		return;
	}

	//
	// Ȃ΂ȏ IRP Ȃ
	//
	UnloadInProgress = TRUE;

	KeReleaseSpinLock(&CountMutex, oldirql);

	//
	// t@CVXefoCX؂藣
	//
	device = SymlinkDriver->DeviceObject;
	while (device) {
		nextDevice = device->NextDevice;
		if (device != SymlinkController) {
			SymlinkDeleteDevice(device);
		}
		device = nextDevice;
	}
}
#endif // DBG


//----------------------------------------------------------------------
//                 I/O [`
//----------------------------------------------------------------------

//----------------------------------------------------------------------
//
// SymlinkFastIoCheckIfPossible
//
//----------------------------------------------------------------------
BOOLEAN
SymlinkFastIoCheckIfPossible(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN BOOLEAN Wait,
	IN ULONG LockKey,
	IN BOOLEAN CheckForReadOperation,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoCheckIfPossible)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoCheckIfPossible(
			FileObject, FileOffset, Length,
			Wait, LockKey, CheckForReadOperation, IoStatus, hookExt->FileSystem);
	}

	return retval;
}


//----------------------------------------------------------------------
// 
// SymlinkFastIoRead
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoRead(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN BOOLEAN Wait,
	IN ULONG LockKey,
	OUT PVOID Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoRead)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoRead(
			FileObject, FileOffset, Length,
			Wait, LockKey, Buffer, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoWrite
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoWrite(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN BOOLEAN Wait,
	IN ULONG LockKey,
	IN PVOID Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT( hookExt, FastIoWrite )) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoWrite(
			FileObject, FileOffset, Length, Wait, LockKey,
			Buffer, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoQueryBasicinfo
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoQueryBasicInfo(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	OUT PFILE_BASIC_INFORMATION Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoQueryBasicInfo)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoQueryBasicInfo(
			FileObject, Wait, Buffer, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoQueryStandardInfo
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoQueryStandardInfo(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	OUT PFILE_STANDARD_INFORMATION Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoQueryStandardInfo)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoQueryStandardInfo(
			FileObject, Wait, Buffer, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoLock
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoLock(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PLARGE_INTEGER Length,
	PEPROCESS ProcessId,
	ULONG Key,
	BOOLEAN FailImmediately,
	BOOLEAN ExclusiveLock,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
    hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoLock)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoLock(
			FileObject, FileOffset, Length, ProcessId, Key, FailImmediately,
			ExclusiveLock, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoUnlockSingle
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoUnlockSingle(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PLARGE_INTEGER Length,
	PEPROCESS ProcessId,
	ULONG Key,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
    hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoUnlockSingle)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoUnlockSingle(
			FileObject, FileOffset, Length, ProcessId, Key,
			IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoUnlockAll
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoUnlockAll(
	IN PFILE_OBJECT FileObject,
	PEPROCESS ProcessId,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoUnlockAll)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoUnlockAll(
			FileObject, ProcessId, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoUnlockAllByKey
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoUnlockAllByKey(
	IN PFILE_OBJECT FileObject,
	PEPROCESS ProcessId,
	ULONG Key,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoUnlockAllByKey)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoUnlockAllByKey(
			FileObject, ProcessId, Key, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoQueryNetworkOpenInfo
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoQueryNetworkOpenInfo(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	OUT struct _FILE_NETWORK_OPEN_INFORMATION *Buffer,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoQueryNetworkOpenInfo)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoQueryNetworkOpenInfo(
			FileObject, Wait, Buffer, IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoAcquireForModWrite
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkFastIoAcquireForModWrite(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER EndingOffset,
	OUT struct _ERESOURCE **ResourceToRelease,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	NTSTATUS retval = STATUS_NOT_IMPLEMENTED;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return STATUS_NOT_IMPLEMENTED;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, AcquireForModWrite)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->AcquireForModWrite(
			FileObject, EndingOffset, ResourceToRelease, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoMdlRead
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoMdlRead(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, MdlRead)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->MdlRead(
			FileObject, FileOffset, Length, LockKey, MdlChain,
			IoStatus, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoMdlReadComplete
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoMdlReadComplete(
	IN PFILE_OBJECT FileObject,
	IN PMDL MdlChain,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, MdlReadComplete)) {
		retval = (BOOLEAN) hookExt->FileSystem->DriverObject->FastIoDispatch->MdlReadComplete(
			FileObject, MdlChain, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoPrepareMdlWrite
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoPrepareMdlWrite(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;
	IoStatus->Status = STATUS_NOT_IMPLEMENTED;
	IoStatus->Information = 0;

	if (FASTIOPRESENT(hookExt, PrepareMdlWrite)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->PrepareMdlWrite(
			FileObject, FileOffset, Length, LockKey, MdlChain, IoStatus,
			hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoMdlWriteComplete
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoMdlWriteComplete(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PMDL MdlChain,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, MdlWriteComplete)) { 
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->MdlWriteComplete(
			FileObject, FileOffset, MdlChain, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoReadCompressed
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoReadCompressed(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PVOID Buffer,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	OUT struct _COMPRESSED_DATA_INFO *CompressedDataInfo,
	IN ULONG CompressedDataInfoLength,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoReadCompressed)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoReadCompressed(
			FileObject, FileOffset, Length, LockKey, Buffer, MdlChain, IoStatus,
			CompressedDataInfo, CompressedDataInfoLength, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoWriteCompressed
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoWriteCompressed( 
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN ULONG Length,
	IN ULONG LockKey,
	OUT PVOID Buffer,
	OUT PMDL *MdlChain,
	OUT PIO_STATUS_BLOCK IoStatus,
	OUT struct _COMPRESSED_DATA_INFO *CompressedDataInfo,
	IN ULONG CompressedDataInfoLength,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoWriteCompressed)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoWriteCompressed(
			FileObject, FileOffset, Length, LockKey, Buffer, MdlChain, IoStatus,
			CompressedDataInfo, CompressedDataInfoLength, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoMdlReadCompleteCompressed
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoMdlReadCompleteCompressed(
	IN PFILE_OBJECT FileObject,
	IN PMDL MdlChain,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, MdlReadCompleteCompressed)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->MdlReadCompleteCompressed(
			FileObject, MdlChain, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoMdlWriteCompleteCompressed
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoMdlWriteCompleteCompressed(
	IN PFILE_OBJECT FileObject,
	IN PLARGE_INTEGER FileOffset,
	IN PMDL MdlChain,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT( hookExt, MdlWriteCompleteCompressed)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->MdlWriteCompleteCompressed(
			FileObject, FileOffset, MdlChain, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoQueryOpen
//
// ̌Ăяo͎ۂ IRP n܂!
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoQueryOpen(
	IN PIRP Irp,
	OUT PFILE_NETWORK_OPEN_INFORMATION NetworkInformation,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (!DeviceObject)
		return FALSE;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, FastIoQueryOpen)) {
		PIO_STACK_LOCATION currentIrpStack = IoGetCurrentIrpStackLocation(Irp);
		PIO_STACK_LOCATION nextIrpStack = IoGetNextIrpStackLocation(Irp);
		PFILE_OBJECT FileObject = currentIrpStack->FileObject;

		//
		// p[^X^bN̎̃xɓn
		//
		*nextIrpStack = *currentIrpStack;
		nextIrpStack->DeviceObject = hookExt->FileSystem;
		IoSetNextIrpStackLocation(Irp);

		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoQueryOpen(
			Irp, NetworkInformation, hookExt->FileSystem);

		//
		// NT 5.0ȑO checked rĥŃX^bN̈ʒu߂
		//
		Irp->CurrentLocation++;
		Irp->Tail.Overlay.CurrentStackLocation++;
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoReleaseForModWrite
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkFastIoReleaseForModWrite(
	IN PFILE_OBJECT FileObject,
	IN struct _ERESOURCE *ResourceToRelease,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	NTSTATUS retval = STATUS_NOT_IMPLEMENTED;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return STATUS_NOT_IMPLEMENTED;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, ReleaseForModWrite)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->ReleaseForModWrite(
		FileObject,  ResourceToRelease, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoAcquireForCcFlush
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkFastIoAcquireForCcFlush(
	IN PFILE_OBJECT FileObject,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	NTSTATUS retval = STATUS_NOT_IMPLEMENTED;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return STATUS_NOT_IMPLEMENTED;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, AcquireForCcFlush)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->AcquireForCcFlush(
			FileObject, hookExt->FileSystem);
	}
	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoReleaseForCcFlush
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkFastIoReleaseForCcFlush(
	IN PFILE_OBJECT FileObject,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	NTSTATUS retval = STATUS_NOT_IMPLEMENTED;
	PHOOK_EXTENSION hookExt;

	if (!DeviceObject)
		return STATUS_NOT_IMPLEMENTED;
	hookExt = DeviceObject->DeviceExtension;

	if (FASTIOPRESENT(hookExt, ReleaseForCcFlush)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->ReleaseForCcFlush(
			FileObject, hookExt->FileSystem);
	}
	return retval;
}


BOOLEAN CallBackFastIoDeviceControl(
	IN PFILE_OBJECT FileObject, IN BOOLEAN Wait,
	IN PVOID InputBuffer, IN ULONG InputBufferLength,
	OUT PVOID OutputBuffer, IN ULONG OutputBufferLength, IN ULONG IoControlCode,
	OUT PIO_STATUS_BLOCK IoStatus, IN PDEVICE_OBJECT DeviceObject)
{
	BOOLEAN rv = FALSE;
	ULONG i;

	PAGED_CODE();
	IoStatus->Status = STATUS_SUCCESS;  // Ɖ
	IoStatus->Information = 0;  // ԂȂƉ

	switch (IoControlCode) {
	case IOCTL_SYMLINK_VERSION:

		//
		// o[Wԍ
		//
		if (OutputBufferLength < sizeof(ULONG)) {
			IoStatus->Status = STATUS_BUFFER_TOO_SMALL;
			return rv;
		}

		*(ULONG *)OutputBuffer = SYMLINKVERSION;
		IoStatus->Information = sizeof(ULONG);
		break;

	case IOCTL_SYMLINK_UNLOADQUERY:
#if DBG
		SymlinkQueryUnload(IoStatus);
#else // DBG
		IoStatus->Information = 1;
#endif // DBG
		break;

	//
	// p~ꂽIoControlCodečėpȂ悤
	// Iɗ񋓂Ă
	//
	case IOCTL_SYMLINK_READ_MEMORY:
		//
		// (p~)w肵AhXf[^ǂݍ
		// fall through
		//
	case IOCTL_SYMLINK_WRITE_MEMORY:
		//
		// (p~)w肵AhXɃf[^
		// fall through
		//
	case IOCTL_SYMLINK_SETDRIVES:
		//
		// (p~)hCũtbNƃAtbNs
		// fall through
		//
	default:

		IoStatus->Status = STATUS_INVALID_DEVICE_REQUEST;
		break;
	}

	return TRUE;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoDeviceControl
//
//----------------------------------------------------------------------
BOOLEAN 
SymlinkFastIoDeviceControl(
	IN PFILE_OBJECT FileObject,
	IN BOOLEAN Wait,
	IN PVOID InputBuffer,
	IN ULONG InputBufferLength,
	OUT PVOID OutputBuffer,
	IN ULONG OutputBufferLength,
	IN ULONG IoControlCode,
	OUT PIO_STATUS_BLOCK IoStatus,
	IN PDEVICE_OBJECT DeviceObject
	)
{
	BOOLEAN retval = FALSE;
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	if (DeviceObject == SymlinkController) {
		//
		// ̃foCXւ̐䃁bZ[W
		//
		return CallBackFastIoDeviceControl(FileObject, Wait, InputBuffer, InputBufferLength,
			OutputBuffer, OutputBufferLength, IoControlCode, IoStatus, DeviceObject);
	}

	//
	// t@CVXěĂяoÂ܂ܓn
	//
	hookExt = DeviceObject->DeviceExtension;
	if (FASTIOPRESENT(hookExt, FastIoDeviceControl)) {
		retval = hookExt->FileSystem->DriverObject->FastIoDispatch->FastIoDeviceControl(
			FileObject, Wait, InputBuffer, InputBufferLength, OutputBuffer,
			OutputBufferLength, IoControlCode, IoStatus, hookExt->FileSystem);
	}

	return retval;
}


//----------------------------------------------------------------------
//
// SymlinkFastIoAcquireFile
//
//----------------------------------------------------------------------
VOID 
SymlinkFastIoAcquireFile(
	PFILE_OBJECT FileObject
	)
{
	PDEVICE_OBJECT deviceObject, checkDevice;
	PHOOK_EXTENSION hookExt;

	//
	// g̃foCXIuWFNgT
	//
	if (FileObject->DeviceObject->Vpb)
		checkDevice = FileObject->DeviceObject->Vpb->DeviceObject;
	else
		checkDevice = FileObject->DeviceObject;
	while (checkDevice) {
		if (checkDevice->DriverObject == SymlinkDriver) {
			//
			// 
			//
			deviceObject = checkDevice;
			hookExt = deviceObject->DeviceExtension;
			if (FASTIOPRESENT(hookExt, AcquireFileForNtCreateSection)) {
				hookExt->FileSystem->DriverObject->FastIoDispatch->AcquireFileForNtCreateSection(
					FileObject);
			}
			return;
		}
		checkDevice = checkDevice->AttachedDevice;
	}
}


//----------------------------------------------------------------------
//
// SymlinkFastIoReleaseFile
//
//----------------------------------------------------------------------
VOID 
SymlinkFastIoReleaseFile(
	PFILE_OBJECT FileObject
	)
{
	PDEVICE_OBJECT deviceObject, checkDevice;
	PHOOK_EXTENSION hookExt;

	//
	// g̃foCXIuWFNgT
	//
	if (FileObject->DeviceObject->Vpb)
		checkDevice = FileObject->DeviceObject->Vpb->DeviceObject;
	else
		checkDevice = FileObject->DeviceObject;
	while (checkDevice) {
		if (checkDevice->DriverObject == SymlinkDriver) {
			deviceObject = checkDevice;
			hookExt = deviceObject->DeviceExtension;

			if (FASTIOPRESENT(hookExt, ReleaseFileForNtCreateSection)) {
				hookExt->FileSystem->DriverObject->FastIoDispatch->ReleaseFileForNtCreateSection(FileObject);
			}
			return;
		}
		checkDevice = checkDevice->AttachedDevice;
	}
}


//----------------------------------------------------------------------
//
// SymlinkFastIoDetachDevice
//
// tbNĂfoCX폜悤ƂĂƂɌĂяoB
// ͂Ƃ΁Atbs[tH[}bgꂽƂɔB
// foCX؂藣č폜Ȃ΂ȂȂB
//
//----------------------------------------------------------------------
VOID 
SymlinkFastIoDetachDevice(
	PDEVICE_OBJECT SourceDevice,
	PDEVICE_OBJECT TargetDevice
	)
{
	PHOOK_EXTENSION hookExt;

	PAGED_CODE();
	//
	// foCX̃foCX̉ō폜悤ƂĂ邩
	// ǂׂBȂÃfoCXłOɂ؂藣
	// ΂ȂȂ
	//
	hookExt = SourceDevice->DeviceExtension;
	if (hookExt->FileSystem == TargetDevice) {
		if (hookExt->Root) {
			KdPrint(("Symlink: Detaching from volume: %wZ\n", &hookExt->Root->Name));
		}
		SymlinkDeleteDevice(SourceDevice);
		return;
	}

	//
	// FastIoDetachDevice ʂ̃foCXɓnƂ͂ȂB
	//
}

//
//  I/O fBXpb`e[uBNT ̓t@CVXehCo
//  I/O ĂяoT|[gĂƉ肷邽߁At@CVXe
// tB^hCoɂ͂̃e[u݂ȂĂ͂ȂȂB
//
static FAST_IO_DISPATCH FastIoHook = {
	sizeof(FAST_IO_DISPATCH),
	SymlinkFastIoCheckIfPossible,
	SymlinkFastIoRead,
	SymlinkFastIoWrite,
	SymlinkFastIoQueryBasicInfo,
	SymlinkFastIoQueryStandardInfo,
	SymlinkFastIoLock,
	SymlinkFastIoUnlockSingle,
	SymlinkFastIoUnlockAll,
	SymlinkFastIoUnlockAllByKey,
	SymlinkFastIoDeviceControl,
	SymlinkFastIoAcquireFile,
	SymlinkFastIoReleaseFile,
	SymlinkFastIoDetachDevice,

	//
	// NT 4.0 ǉ
	//
	SymlinkFastIoQueryNetworkOpenInfo,
	SymlinkFastIoAcquireForModWrite,
	SymlinkFastIoMdlRead,
	SymlinkFastIoMdlReadComplete,
	SymlinkFastIoPrepareMdlWrite,
	SymlinkFastIoMdlWriteComplete,
	SymlinkFastIoReadCompressed,
	SymlinkFastIoWriteCompressed,
	SymlinkFastIoMdlReadCompleteCompressed,
	SymlinkFastIoMdlWriteCompleteCompressed,
	SymlinkFastIoQueryOpen,
	SymlinkFastIoReleaseForModWrite,
	SymlinkFastIoAcquireForCcFlush,
	SymlinkFastIoReleaseForCcFlush,
};


//----------------------------------------------------------------------
//     ʒmR[obN֐
//----------------------------------------------------------------------


VOID SymlinkFsNotification(
	PDEVICE_OBJECT DeviceObject,
	BOOLEAN FsActive
	)
{
	NTSTATUS status;
	UNICODE_STRING fsName;
	PDEVICE_OBJECT hookDevice, checkDevice, fsDevice;
	PHOOK_EXTENSION hookExtension;

	PAGED_CODE();
	KdPrint(("SymlinkFsNotification(%p, %d)\n", DeviceObject, FsActive ? 1 : 0));

	//
	// foCX̎ނfBXNACDAe[v̂ꂩł邱Ƃ
	// mF(ȊÕfoCXɊւĒʒm邱Ƃ͂Ȃ͂ł邪)
	// [gRs[^̃Nւ̃ANZXɂ͖Ή
	//
	if (DeviceObject->DeviceType != FILE_DEVICE_DISK_FILE_SYSTEM &&
		DeviceObject->DeviceType != FILE_DEVICE_CD_ROM_FILE_SYSTEM &&
		DeviceObject->DeviceType != FILE_DEVICE_TAPE_FILE_SYSTEM/* &&
		DeviceObject->DeviceType != FILE_DEVICE_NETWORK_FILE_SYSTEM*/)
		return;

	RtlInitUnicodeString(&fsName, L"\\FileSystem\\Fs_Rec");
	if (!RtlCompareUnicodeString(&DeviceObject->DriverObject->DriverName, &fsName, TRUE)) {
		//
		// ROiCUɂ͐ڑȂ
		//
		return;
	}
	RtlInitUnicodeString(&fsName, L"\\FileSystem\\Fastfat");
	if (!RtlCompareUnicodeString(&DeviceObject->DriverObject->DriverName, &fsName, TRUE)) {
		//
		// FAT̓p[X|CgT|[gȂ
		// Windows 2000  DFS tB^̃oO邽߂ɂڑȂ
		//
		return;
	}

	KdPrint(("%wZ (Type=%d)\n", &DeviceObject->DriverObject->DriverName, DeviceObject->DeviceType));

	if (FsActive) {
		//
		// [gt@CVXeɂ̓}Eg̊TOȂB
		// Create IRP ͒ڃRg[foCXɔłB
		//
		if (DeviceObject->DeviceType == FILE_DEVICE_NETWORK_FILE_SYSTEM) {
			SymlinkFilterDevice(DeviceObject);
			return;
		}
		// ȍ~̓[Jt@CVXȅꍇ
		// ̃foCXt@CVXeƂēo^悤ƂĂȂA
		// VtB^foCX쐬ĐڑBtB^foCX
		// foCX^CvgĂ*ȂȂ*BȂƁASIŜ悤
		// ̂ۂɂ̃t@CVXełƂ݂Ȃ邩ȂB
		status = IoCreateDevice(SymlinkDriver,
		                        sizeof(HOOK_EXTENSION),
		                        NULL,
		                        FILE_DEVICE_FILE_SYSTEM,
		                        0,
		                        FALSE,
		                        &hookDevice);
		if (!NT_SUCCESS(status))
			return;
		KdPrint(("Symlink about to hook onto %p with hook device %p.\n",
		         DeviceObject, hookDevice));

		hookExtension = hookDevice->DeviceExtension;
		hookExtension->FileSystem =
			IoAttachDeviceToDeviceStack(hookDevice, DeviceObject);

		if (hookExtension->FileSystem) {
			hookDevice->Flags &= ~DO_DEVICE_INITIALIZING;
			KdPrint(("Symlink successfully attached to %p.\n",
			         hookExtension->FileSystem));
		} else {
			KdPrint(("Symlink failed to attach to %p.\n", DeviceObject));
			SymlinkDeleteDevice(hookDevice);
		}

		//
		// t@CVXehCõfoCXXgT
		// }Egς݂̃{[ׂĂɐڑB
		//
		for (fsDevice = DeviceObject->DriverObject->DeviceObject;
		     fsDevice;
		     fsDevice = fsDevice->NextDevice) {
			// Rg[foCX̓XLbv
			if (fsDevice == DeviceObject)
				continue;
			// foCX̎ނmF
			if (fsDevice->DeviceType != FILE_DEVICE_DISK_FILE_SYSTEM &&
				fsDevice->DeviceType != FILE_DEVICE_CD_ROM_FILE_SYSTEM &&
				fsDevice->DeviceType != FILE_DEVICE_TAPE_FILE_SYSTEM)
				continue;
			SymlinkFilterDevice(fsDevice);
		}
	} else {
		// ̃foCXt@CVXeƂēo^ł΁A
		// ؂藣KvB܂ALĂ
		// ڑĂfoCXKvB
		for (checkDevice = DeviceObject->AttachedDevice;
				checkDevice;
				checkDevice = checkDevice->AttachedDevice) {
			if (checkDevice->DriverObject == SymlinkDriver) {
				hookDevice = checkDevice;
				KdPrint(("The device going away is attached by Symlink device %p.\n"));
				IoDetachDevice(DeviceObject);
				hookExtension = hookDevice->DeviceExtension;
				hookExtension->FileSystem = NULL;
				// foCX폜ׂA
				// NڑĂƂɂ̂͌Ȃ
				if (!hookDevice->AttachedDevice)
					SymlinkDeleteDevice(hookDevice);
			}
		}
	}
}


//----------------------------------------------------------------------
//     fBXpb`ƃtbÑGg|Cg
//----------------------------------------------------------------------


VOID SymlinkUnload(IN PDRIVER_OBJECT DriverObject)
{
	WCHAR deviceLinkBuffer[] = L"\\DosDevices\\SymLink";
	UNICODE_STRING deviceLinkUnicodeString;

	//
	// t@CVXeo^ʒm̓o^
	//
	IoUnregisterFsRegistrationChange(DriverObject, SymlinkFsNotification);

	//
	// V{bNN폜
	//
	RtlInitUnicodeString(&deviceLinkUnicodeString, deviceLinkBuffer);
	IoDeleteSymbolicLink(&deviceLinkUnicodeString);

	KdPrint(("Symlink: unloading\n"));

	//
	// foCX폜
	//
	while (DriverObject->DeviceObject) {
		SymlinkDeleteDevice(DriverObject->DeviceObject);
	}
	KdPrint(("Symlink: deleted devices\n"));

	//
	// 蓖ĂĂׂĉ
	//
	ExDeletePagedLookasideList(&FullPathLookaside);
}


//----------------------------------------------------------------------
//
// SymlinkResolveLink
//
// V{bNN̉s
//
//----------------------------------------------------------------------
VOID SymlinkResolveLink(IN PIRP Irp, IN PIO_STACK_LOCATION IrpSp, IN PWSTR fullPathName)
{
	PREPARSE_DATA_BUFFER reparse;
	UNICODE_STRING NewFileName;
	PUNICODE_STRING FileName;
	UNICODE_STRING directory, unparsed;
	BOOLEAN relative;
	ULONG bufferLength;
	PWSTR ptr;

	PAGED_CODE();
	//
	// V{bNÑp[X^OԂĂׂBꍇA
	// ̃tB^hCo\̂Status͂̂܂
	//
	if (Irp->IoStatus.Status != STATUS_REPARSE
	|| Irp->IoStatus.Information != IO_REPARSE_TAG_SYMLINK) {
		return;
	}

	//
	// G[`FbN
	// REPARSE_DATA_BUFFER̓[U[[h̃R[hDȒlݒł
	//
	reparse = (PREPARSE_DATA_BUFFER)Irp->Tail.Overlay.AuxiliaryBuffer;
	if (!reparse
	|| reparse->ReparseDataLength > MAXIMUM_REPARSE_DATA_BUFFER_SIZE
	|| reparse->ReparseDataLength < reparse->SymbolicLinkReparseBuffer.PrintNameOffset
	|| reparse->ReparseDataLength < reparse->SymbolicLinkReparseBuffer.PrintNameLength
	|| reparse->ReparseDataLength < reparse->SymbolicLinkReparseBuffer.PrintNameOffset
	                                + reparse->SymbolicLinkReparseBuffer.PrintNameLength) {
		Irp->IoStatus.Status = STATUS_IO_REPARSE_DATA_INVALID;
		Irp->IoStatus.Information = 0;
		KdPrint(("unexpected reprase data buffer.\n"));
		return;
	}

	//
	// SRV ̗vł邩ǂׂ
	// ZLeB̗R烊[g symlink ̓NCAg
	// sȂĂ͂ȂȂB
	//
	if (IoIsSystemThread(Irp->Tail.Overlay.Thread)) {
		SECURITY_IMPERSONATION_LEVEL ImpersonationLevel;
		BOOLEAN EffectiveOnly, CopyOnOpen;
		//PTOKEN_SOURCE lpTokenSource;
		PACCESS_TOKEN lpToken;

		lpToken = PsReferenceImpersonationToken(Irp->Tail.Overlay.Thread,
			&CopyOnOpen, &EffectiveOnly, &ImpersonationLevel);
		if (lpToken) {
			KdPrint(("Maybe request from SRV. status=%08x path=%S\n", Irp->IoStatus.Status, fullPathName));
			PsDereferenceImpersonationToken(lpToken);
			Irp->IoStatus.Status = STATUS_STOPPED_ON_SYMLINK;
			Irp->IoStatus.Information = 0;
			return;
		}
	}

	//
	// tpXKv
	//
	if (!fullPathName || !*fullPathName) {
		Irp->IoStatus.Status = STATUS_OBJECT_PATH_NOT_FOUND;
		Irp->IoStatus.Information = 0;
		KdPrint(("fullPathName is null or empty.\n"));
		return;
	}
	//if (IrpSp->FileObject) KdPrint((">%.*S\n", IrpSp->FileObject->FileName.Length / sizeof(WCHAR), IrpSp->FileObject->FileName.Buffer));
	RtlInitUnicodeString(&directory, fullPathName);
	//
	// ReservedtB[h̓pX̖͂̃̕oCg
	//
	if (directory.Length < reparse->Reserved) {
		Irp->IoStatus.Status = STATUS_IO_REPARSE_DATA_INVALID;
		Irp->IoStatus.Information = 0;
		KdPrint(("directory.Length is insufficient.\n"));
		return;
	}
	directory.Length -= reparse->Reserved;
	//
	// obNXbV疢͂̕Ɋ܂߂
	//
	ptr = directory.Buffer + (directory.Length / sizeof(WCHAR)) - 1;
	if (ptr > directory.Buffer && *ptr == L'\\') {
		ptr--;
		directory.Length -= 2;
	}
	RtlInitUnicodeString(&unparsed, fullPathName + directory.Length / sizeof(WCHAR));
	KdPrint(("%wZ|%wZ\n", &directory.Length, &unparsed));
	//
	// ŏIR|[lg菜
	//
	while (ptr > directory.Buffer) {
		if (*ptr == L'\\')
			break;
		ptr--;
	}
	if (ptr <= directory.Buffer) {
		Irp->IoStatus.Status = STATUS_OBJECT_PATH_NOT_FOUND;
		Irp->IoStatus.Information = 0;
		return;
	}
	directory.Length = (ptr + 1 - directory.Buffer) * sizeof(WCHAR);

	//
	// Nt@C̕gݗ
	//
	NewFileName.Length = reparse->SymbolicLinkReparseBuffer.SubstituteNameLength;
	NewFileName.MaximumLength = NewFileName.Length + 1;
	NewFileName.Buffer = reparse->SymbolicLinkReparseBuffer.PathBuffer +
			reparse->SymbolicLinkReparseBuffer.SubstituteNameOffset / sizeof(WCHAR);

	//
	// ΃pX
	//
	relative = (reparse->SymbolicLinkReparseBuffer.Flags & 1) != 0;
	if (relative) {
		//
		// NewFileName ̐擪 ..\ 폜
		// directory Kw菜
		//
		while (NewFileName.Length > 3 * sizeof(WCHAR) && NewFileName.Buffer[0] == L'.' &&
		       NewFileName.Buffer[1] == L'.' && NewFileName.Buffer[2] == L'\\') {
			NewFileName.Length -= 3 * sizeof(WCHAR);
			NewFileName.MaximumLength -= 3 * sizeof(WCHAR);
			NewFileName.Buffer += 3;
			// ͕K \ Ȃ̂ŃXLbv
			ptr = directory.Buffer + (directory.Length / sizeof(WCHAR)) - 2;
			ASSERT(ptr[1] == L'\\');
			while (ptr > directory.Buffer) {
				if (*ptr == L'\\')
					break;
				ptr--;
			}
			if (ptr <= directory.Buffer) {
				Irp->IoStatus.Status = STATUS_OBJECT_PATH_NOT_FOUND;
				Irp->IoStatus.Information = 0;
				return;
			}
			directory.Length = (ptr + 1 - directory.Buffer) * sizeof(WCHAR);
		}

		bufferLength = directory.Length + NewFileName.Length + unparsed.Length;
	} else {
		bufferLength = NewFileName.Length + unparsed.Length;
	}

	FileName = &(IrpSp->FileObject->FileName);
	//KdPrint(("Reparse(%d): %.*S=>%.*S\n", relative,
			//FileName->Length / sizeof(WCHAR), FileName->Buffer,
			//NewFileName.Length / sizeof(WCHAR), NewFileName.Buffer));
	if (FileName->Length < bufferLength) {
		//
		// Ċ蓖Ăs
		//
		PVOID FileNameBuffer = ExAllocatePool(NonPagedPool, bufferLength + 1);
		if (!FileNameBuffer) {
			//
			// s
			//
			Irp->IoStatus.Status = STATUS_INSUFFICIENT_RESOURCES;
			Irp->IoStatus.Information = 0;
			return;
		}
		ExFreePool(FileName->Buffer);
		FileName->Buffer = FileNameBuffer;
		FileName->MaximumLength = (USHORT)bufferLength + 1;
	}

	if (relative) {
		RtlCopyUnicodeString(FileName, &directory);
		RtlAppendUnicodeStringToString(FileName, &NewFileName);
		RtlAppendUnicodeStringToString(FileName, &unparsed);
	} else {
		RtlCopyUnicodeString(FileName, &NewFileName);
		RtlAppendUnicodeStringToString(FileName, &unparsed);
	}
	KdPrint(("Reparse(%d): %wZ\n", relative, FileName));
	Irp->IoStatus.Information = IO_REPARSE;
}


//----------------------------------------------------------------------
//
// SymlinkQueryAttributeTag
//
// FileAttributeTagInformation̖₢킹
//
//----------------------------------------------------------------------
VOID SymlinkQueryAttributeTag(IN PIRP Irp, IN PIO_STACK_LOCATION IrpSp)
{
	PFILE_ATTRIBUTE_TAG_INFORMATION AttrTag;

	PAGED_CODE();
	//
	// G[Ȃ炱ł͉Ȃ
	//
	if (!NT_SUCCESS(Irp->IoStatus.Status))
		return;

	//
	// V{bNNȊOȂ炱ł͉Ȃ
	//
	AttrTag = (PFILE_ATTRIBUTE_TAG_INFORMATION)Irp->AssociatedIrp.SystemBuffer;
	if (AttrTag->ReparseTag != IO_REPARSE_TAG_SYMLINK)
		return;

	//
	// FileAttributeTagInformation͍폜⃊l[OɃp[X|CgǂA
	// ܂p[X|Cg}Eg|Cgł邩ǂ`FbN邽߂
	// gB}Eg|CgȊÕp[X|Cgׂ͂ăN悪폜
	// Ă܂̂ŁA(IsReparseTagNameSurrogatê͉߂ɂ?)
	// p[X|CgNAI/O}l[WxB
	//
	AttrTag->FileAttributes &= ~(FILE_ATTRIBUTE_REPARSE_POINT);

	//KdPrint(("Attr=%08lx, Tag=%08lx\n", AttrTag->FileAttributes, AttrTag->ReparseTag));
}


//----------------------------------------------------------------------
//
// SymlinkHookDone
//
// ߂Xe[^X̏𓾂悤Ƀt@CVXȇ삪
// Ő𓾂
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkHookDone(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp,
	IN PVOID Context
	)
{
	PIO_STACK_LOCATION IrpSp;
	PWSTR fullPathName = (PWSTR)Context;

	PAGED_CODE();
	//
	// v͊ - ʂ
	//
	IrpSp = IoGetCurrentIrpStackLocation(Irp);

	switch (IrpSp->MajorFunction) {
	case IRP_MJ_FILE_SYSTEM_CONTROL:
		//
		// G[̂Ƃ͉Ȃ
		//
		if (NT_SUCCESS(Irp->IoStatus.Status))
			SymlinkFilterDevice(((PDEVICE_OBJECT)Context)->Vpb->DeviceObject);
		break;
	case IRP_MJ_CREATE:
		SymlinkResolveLink(Irp, IrpSp, fullPathName);
		//
		// obt@
		//
		if (fullPathName) {
			ExFreeToPagedLookasideList(&FullPathLookaside, fullPathName);
		}
		break;
	case IRP_MJ_QUERY_INFORMATION:
		SymlinkQueryAttributeTag(Irp, IrpSp);
		break;
	}

	return Irp->IoStatus.Status;
}


//----------------------------------------------------------------------
//
// SymlinkSignalEvent
//
// fBXpb`[`֓Iɖ߂邽߂̃CxgVOi
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkSignalEvent(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp,
	IN PVOID Context
	)
{
	if (Irp->PendingReturned) {
		KeSetEvent((PKEVENT)Context, IO_NO_INCREMENT, FALSE);
	}
	return STATUS_MORE_PROCESSING_REQUIRED;
}


//----------------------------------------------------------------------
//
// SymlinkHookRoutine
//
// t@CVXeɑ悤ƂĂĂяoł邩ׂ
// C̃tbN[`
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkHookRoutine(
	PDEVICE_OBJECT HookDevice,
	IN PIRP Irp
	)
{
	PIO_STACK_LOCATION currentIrpStack = IoGetCurrentIrpStackLocation(Irp);
	PIO_STACK_LOCATION nextIrpStack = IoGetNextIrpStackLocation(Irp);
	PFILE_OBJECT FileObject;
	PHOOK_EXTENSION hookExt;
	PWSTR fullPathName = NULL;
	BOOLEAN hookCompletion;
	KIRQL oldirql;
	PVOID context = NULL;
	KEVENT event;
	NTSTATUS status;

	//
	// t@CIuWFNg IRP o
	//
	FileObject = currentIrpStack->FileObject;

	//
	//  IRP ǂ̃t@CVXepȂ̂̏܂
	// foCXGNXeVw
	//
	hookExt = HookDevice->DeviceExtension;

	hookCompletion = FALSE;
	switch (currentIrpStack->MajorFunction) {
	case IRP_MJ_FILE_SYSTEM_CONTROL:
		//
		// ڑĂt@CVXeɑ΂}Egv𒲂ׂ
		// X^bNʒuɋ󂫂Ί[` IRP ɐݒ肷
		//
		if (currentIrpStack->MinorFunction == IRP_MN_MOUNT_VOLUME) {
			if (hookExt->FileSystem != NULL &&
				Irp->CurrentLocation >= HookDevice->StackSize) {
				hookCompletion = TRUE;
				context = currentIrpStack->Parameters.MountVolume.Vpb->RealDevice;
			}
		}
		break;
	case IRP_MJ_CREATE:
		//
		// test2\test.txt JƂĂ
		// test2 N̏ꍇAFILE_OPEN_REPARSE_POINT w肵ĂĂ
		// STATUS_REPARSE ̂ postCreate ͕̏Kv
		//
		hookCompletion = TRUE;
		fullPathName = ExAllocateFromPagedLookasideList(&FullPathLookaside);
		if (fullPathName) {
			SymlinkGetFullPath(FileObject, hookExt, fullPathName);
		}
		context = fullPathName;
		break;
	case IRP_MJ_QUERY_INFORMATION:
		//
		// ̂ FileAttributeTagInformation ̂
		//
		hookCompletion = currentIrpStack->Parameters.QueryFile.FileInformationClass == FileAttributeTagInformation;
		break;
	}

	//
	// p[^̉ɂhCo̎x̃X^bNɓn
	//
	*nextIrpStack = *currentIrpStack;

#if DBG
	//
	// A[hisłȂ΁A
	// IRP̖߂Xe[^X𒲂ׂ悤Ɋ[`o^
	//
	KeAcquireSpinLock(&CountMutex, &oldirql);
#endif
	if (UnloadInProgress)
		hookCompletion = FALSE;
	if (hookCompletion) {
#if DBG
		//
		// [`ݒ肷̂Őis IRP ̐𑝂₷
		//
		SymlinkDriver->DriverUnload = NULL;
		OutstandingIRPCount++;
		//KdPrint(("+%d: %x\n", OutstandingIRPCount, Irp));
#endif // DBG
		IoSetCompletionRoutine(Irp, SymlinkSignalEvent, &event, TRUE, TRUE, TRUE);
	} else {
		//
		// [`ݒ肵Ȃ
		//
		IoSetCompletionRoutine(Irp, SymlinkSignalEvent, NULL, FALSE, FALSE, FALSE);
	}
#if DBG
	KeReleaseSpinLock(&CountMutex, oldirql);
#endif
	if (hookCompletion) {
		KeInitializeEvent(&event, NotificationEvent, FALSE);
		status = IoCallDriver(hookExt->FileSystem, Irp);
		if (status == STATUS_PENDING) {
			KeWaitForSingleObject(&event, Executive, KernelMode, FALSE, NULL);
		}
		SymlinkHookDone(HookDevice, Irp, context);
#if DBG
		//
		// IRP ̏̂Őis IRP ̐炷
		//
		KeAcquireSpinLock(&CountMutex, &oldirql);
		OutstandingIRPCount--;
		//KdPrint(("-%d: %x\n", OutstandingIRPCount, Irp));
		if (!OutstandingIRPCount)
			SymlinkDriver->DriverUnload = SymlinkUnload;
		KeReleaseSpinLock(&CountMutex, oldirql);
#endif
		status = Irp->IoStatus.Status;
		IoCompleteRequest(Irp, IO_NO_INCREMENT);
	} else {
		status = IoCallDriver(hookExt->FileSystem, Irp);
	}
	//
	// ĂяoʂĂяoɕԂ
	//
	return status;
}


NTSTATUS SymlinkDeviceRoutine(IN PDEVICE_OBJECT DeviceObject, IN PIRP irp)
{
	PIO_STACK_LOCATION irpStack;
	PVOID inputBuffer;
	PVOID outputBuffer;
	ULONG inputBufferLength;
	ULONG outputBufferLength;
	ULONG ioControlCode;
	NTSTATUS status;

	//
	// Ɖ
	//
	irp->IoStatus.Status = STATUS_SUCCESS;
	irp->IoStatus.Information = 0;

	//
	// IRP݈̌ʒuւ̃|C^擾
	//
	irpStack = IoGetCurrentIrpStackLocation(irp);

	//
	// o̓obt@Ƃ̒擾
	//
	inputBuffer = irp->AssociatedIrp.SystemBuffer;
	inputBufferLength = irpStack->Parameters.DeviceIoControl.InputBufferLength;
	outputBuffer = irp->AssociatedIrp.SystemBuffer;
	outputBufferLength = irpStack->Parameters.DeviceIoControl.OutputBufferLength;
	ioControlCode = irpStack->Parameters.DeviceIoControl.IoControlCode;

	switch (irpStack->MajorFunction) {
	case IRP_MJ_CREATE:

		KdPrint(("Symlink: IRP_MJ_CREATE"));

		break;

	case IRP_MJ_CLOSE:

		KdPrint(("Symlink: IRP_MJ_CLOSE"));

		break;

	case IRP_MJ_DEVICE_CONTROL:

		KdPrint(("Symlink: IRP_MJ_DEVICE_CONTROL"));

		//
		// o̓obt@MDLƂēnĂ炻擾
		//
		if (irp->MdlAddress) {
			outputBuffer = MmGetSystemAddressForMdl(irp->MdlAddress);
		}

		//
		// nhĂяo
		//
		CallBackFastIoDeviceControl(irpStack->FileObject, TRUE,
		                            inputBuffer, inputBufferLength,
		                            outputBuffer, outputBufferLength,
		                            ioControlCode, &irp->IoStatus, DeviceObject);

		break;
	}

	//
	// IoCompleteRequest ̌ IRP QƂĂ͂ȂȂ̂
	// Xe[^XҔ
	//
	status = irp->IoStatus.Status;
	//
	// IRP
	//
	IoCompleteRequest(irp, IO_NO_INCREMENT);
	return status;
}


//----------------------------------------------------------------------
//
// SymlinkDispatch
//
// Irp ǂ̃foCXɌĂ邩ɊÂāAt@CVXe
// tB^֐Ag̃foCX[`̂ǂ炩ĂяoB
//
//----------------------------------------------------------------------
NTSTATUS 
SymlinkDispatch(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp
	)
{
	//
	// NGXg UI 痈̂AtbNĂt@CVXe
	// hCoɌꂽ̂肷B
	//
	if (DeviceObject == SymlinkController) {
		return SymlinkDeviceRoutine(DeviceObject, Irp);
	} else {
		return SymlinkHookRoutine(DeviceObject, Irp);
	}
}


NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath)
{
	NTSTATUS status;
	PDEVICE_OBJECT device;
	WCHAR deviceNameBuffer[] = L"\\Device\\SymLink";
	UNICODE_STRING deviceNameUnicodeString;
	WCHAR deviceLinkBuffer[] = L"\\DosDevices\\SymLink";
	UNICODE_STRING deviceLinkUnicodeString;
	ULONG i;
	PDEVICE_OBJECT fsDevice;
	PFILE_OBJECT fileObject;

	KdPrint(("Symlink: entering DriverEntry\n"));
	SymlinkDriver = DriverObject;

	//
	// foCX쐬
	//
	RtlInitUnicodeString(&deviceNameUnicodeString, deviceNameBuffer);

	status = IoCreateDevice(DriverObject,
	                        0, // foCX̃foCXg͕sv
	                        &deviceNameUnicodeString,
	                        FILE_DEVICE_UNKNOWN,
	                        FILE_DEVICE_SECURE_OPEN,
	                        TRUE,
	                        &device);

	if (!NT_SUCCESS(status)) {
		KdPrint(("Symlink: failed to create our device!\n"));
		return status;
	}

	//
	// foCXƃ}[N
	//
	SymlinkController = device;

	//
	// V{bNN쐬
	//
	RtlInitUnicodeString(&deviceLinkUnicodeString, deviceLinkBuffer);

	status = IoCreateSymbolicLink(&deviceLinkUnicodeString, 
	                              &deviceNameUnicodeString);
	if (!NT_SUCCESS(status)) {
		KdPrint(("Symlink: IoCreateSymbolicLink failed\n"));
		IoDeleteDevice(device);
		return status;
	}

	//
	// fBXpb`|Cg쐬
	//
	for (i = 0; i <= IRP_MJ_MAXIMUM_FUNCTION; i++) {
		DriverObject->MajorFunction[i] = SymlinkDispatch;
	}
#if DBG
	DriverObject->DriverUnload = SymlinkUnload;
#endif // DBG
	//
	//  I/O fBXpb`e[uݒ
	//
	DriverObject->FastIoDispatch = &FastIoHook;

	//
	// IuWFNg
	//
#if DBG
	KeInitializeSpinLock(&CountMutex);
#endif

	//
	// t@C lookaside 
	//
	ExInitializePagedLookasideList(&FullPathLookaside, NULL, NULL,
				     0, MAXPATHLEN * 2, 'lmyS', 0);

	// t@CVXe̗L/ʒmMł悤
	// ̃hCoo^
	status = IoRegisterFsRegistrationChange(DriverObject,
	                                        SymlinkFsNotification);
	if (!NT_SUCCESS(status)) {
		KdPrint(("Symlink: IoRegisterFsRegistrationChange failed\n"));
		SymlinkUnload(DriverObject);
		return status;
	}

	//
	// Windows 2000 ł IoRegisterFsRegistrationChange 
	// [hς݂̃t@CVXeʒmȂ̂ŁA
	// \Ntfs ŊJĒʒmV~[g
	//
	RtlInitUnicodeString(&deviceNameUnicodeString, L"\\Ntfs");
	status = IoGetDeviceObjectPointer(&deviceNameUnicodeString, FILE_READ_ATTRIBUTES, &fileObject, &fsDevice);
	if (NT_SUCCESS(status)) {
		SymlinkFsNotification(fsDevice, TRUE);
		ObDereferenceObject(fileObject);
	}

	return STATUS_SUCCESS;
}

